;  A 16-bit DOS HelloWorld program originally by RedOx.  Produces a small model .EXE executable.

; To assemble and link from within WinAsm Studio, you must have a special 16-bit linker, 
; such as the one in the archive at this URL- http://win32assembly.online.fr/files/Lnk563.exe
; Run the archive to unpack Link.exe, rename the Link.exe file to Link16.exe and copy it
; into the \masm32\bin folder.

.386		
option	segment:use16




keen_pos_x	equ	6EDEh
keen_pos_y	equ	6EE2h


pos_x	equ	08224h
pos_y	equ	08228h
box_left_x	equ	0822Ch
box_top_y	equ	08230h
box_right_x	equ	08234h
box_bot_y	equ	08238h
del_x	equ 	0823Ch
del_y	equ	0823Eh
vel_x	equ	08240h
vel_y	equ	08242h


map_width	equ	6C08h
tile_data_1	equ	6C48h




dseg		segment	para public use16 'data'
dseg		ends

dif_x	equ	2F22h
dif_y	equ	2F26h
shot_speed	equ	2F2Ah
shot_vel_x	equ	2F32h
shot_vel_y	equ	2F34h

wptr	typedef near ptr word
dwptr	typedef near ptr dword
r8ptr	typedef near ptr real8


cseg	segment	para public use16  'code'
	assume	cs:cseg, ds:dseg

ORG	2F20h
jmp	SHOOT_AT_KEEN

v_dif_x	dword	0
v_dif_y	dword	0
v_shot_speed	real8	500.0
v_shot_vel_x	word	0
v_shot_vel_y	word	0

SHOOT_AT_KEEN:
push	ax
mov	eax, ds:[keen_pos_x]	;compute dif_x
sub	eax, [si+4]
add	eax, 200		;correction
mov	dword ptr cs:[dif_x], eax

mov	eax, ds:[keen_pos_y]	;compute dif_y
sub	eax, [si+8]
add	eax, 600
mov	dword ptr cs:[dif_y], eax


fild	dword ptr cs:[dif_y]
fchs	
fild	dword ptr cs:[dif_x]
			;st(0) = dif_x, st(1) = -dif_y

fpatan			;st(0) = theta
fst	st(1)		;st(0) = st(1) = theta

fcos
fmul	real8 ptr cs:[shot_speed]
fistp	word ptr cs:[shot_vel_x]	;store shot x velocity

fsin
fmul	real8 ptr cs:[shot_speed]
fchs	


fistp	word ptr cs:[shot_vel_y]	;store shot y velocity	

mov	ax, word ptr cs:[shot_vel_x]		
mov	word ptr ds:[si + 32], ax 

mov	ax, word ptr cs:[shot_vel_y]
mov	word ptr ds:[si + 34], ax

pop	ax

jmp	RETURN_TO_SPAWN


ORG	4915h
RETURN_TO_SPAWN:



cseg	ends
end